/* ************************************************************** *
 *                                                                *
 * Copyright (c) 2005, Kota Mizushima, All rights reserved.       *
 *                                                                *
 *                                                                *
 * This software is distributed under the modified BSD License.   *
 * ************************************************************** */
package org.onion_lang.onion.compiler.problem;

import org.onion_lang.onion.lang.syntax.SourcePosition;

/**
 * @author Kota Mizushima
 * 
 */
public class CompilationProblem {
  private String sourceFile;
  private SourcePosition sourcePosition;
  private String message;
  
  public CompilationProblem(
    String sourceFile, SourcePosition sourcePosition, String message) {
    this.sourceFile = sourceFile;
    this.sourcePosition = sourcePosition;
    this.message = message;
  }
  
  public String getSourceFile(){
    return sourceFile;
  }
  
  public SourcePosition getSourcePosition(){
    return sourcePosition;
  }
  
  public String getMessage() {
    return message;
  }
  
}
