/* ************************************************************** *
 *                                                                *
 * Copyright (c) 2005, Kota Mizushima, All rights reserved.       *
 *                                                                *
 *                                                                *
 * This software is distributed under the modified BSD License.   *
 * ************************************************************** */
package org.onion_lang.onion.lang.kernel;

import org.onion_lang.onion.lang.kernel.type.TypeSymbol;

/**
 * @author Kota Mizushima
 * Date: 2005/04/17
 */
public class CastNode extends ExpressionNode {    
  public ExpressionNode target;
  public TypeSymbol conversion;

  public CastNode(ExpressionNode target, TypeSymbol conversion){
    this.target = target;
    this.conversion = conversion;
  }
  
  public TypeSymbol getConversion() {
    return conversion;
  }
  
  public ExpressionNode getTarget() {
    return target;
  }
  
  public TypeSymbol type(){
    return conversion;
  }
}