/* ************************************************************** *
 *                                                                *
 * Copyright (c) 2005, Kota Mizushima, All rights reserved.       *
 *                                                                *
 *                                                                *
 * This software is distributed under the modified BSD License.   *
 * ************************************************************** */
package org.onion_lang.onion.lang.kernel.type;


/**
 * @author Kota Mizushima
 * Date: 2005/04/17
 */
public class BasicSymbol implements TypeSymbol {
  public static final BasicSymbol BYTE = new BasicSymbol("byte");
  public static final BasicSymbol SHORT = new BasicSymbol("short");
  public static final BasicSymbol CHAR = new BasicSymbol("char");
  public static final BasicSymbol INT = new BasicSymbol("int");
  public static final BasicSymbol LONG = new BasicSymbol("long");
  public static final BasicSymbol FLOAT = new BasicSymbol("float");
  public static final BasicSymbol DOUBLE = new BasicSymbol("double");
  public static final BasicSymbol BOOLEAN = new BasicSymbol("boolean");
  public static final BasicSymbol VOID = new BasicSymbol("void");  
  
  private String name;
  
  private BasicSymbol(String name) {
    this.name = name;
  }
  
  public String getName(){
    return name;
  }
  
  public boolean isNumeric(){
    return 
    	this == BYTE ||
    	this == SHORT ||
    	this == INT ||
    	this == LONG ||
    	this == FLOAT ||
    	this == DOUBLE;
  }
  
  public boolean isInteger(){
    return
    	this == BYTE || this == SHORT || this == INT || this == LONG;
  }
  
  public boolean isReal(){
    return this == FLOAT || this == DOUBLE;
  }
  
  public boolean isBoolean(){
    return this == BOOLEAN;
  }
  
  public boolean isArrayType() {
    return false;
  }
  
  public boolean isBasicType() {
    return true;
  }
  
  public boolean isClassType() {
    return false;
  }
  
  public boolean isNullType() {
    return false;
  }

  public boolean isReferenceType() {
    return false;
  }
}